(* $Id: gMozembed.ml,v 1.1.1.1 2002/03/18 13:50:35 furuse Exp $ *)

open Gaux
open Gtk
open GtkBase
open GObj
open GContainer
open GtkMozembed

class mozembed_skel obj = object (self)
  inherit container obj
  method load_url = load_url obj
  method stop_load = stop_load obj
  method can_go_back = can_go_back obj
  method can_go_forward = can_go_forward obj
  method go_back = go_back obj
  method go_forward = go_forward obj
  method render_data = render_data obj
  method open_stream = open_stream obj
  method append_data = append_data obj
  method close_stream = close_stream obj
  method get_link_message = get_link_message obj
  method get_js_status = get_js_status obj
  method get_title = get_title obj
  method get_location = get_location obj
  method reload = reload obj
  method set_chrome_mask = set_chrome_mask obj
  method get_chrome_mask = get_chrome_mask obj
end

class mozembed_signals obj = object
  inherit container_signals obj
  method link_message = 
    GtkSignal.connect ~sgn:GtkMozembed.Signals.link_message ~after obj
  method js_status =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.js_status ~after obj
  method location =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.location ~after obj
  method title =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.title ~after obj
  method progress =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.progress ~after obj
  method progress_all =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.progress_all ~after obj
  method net_state =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.net_state ~after obj
  method net_state_all =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.net_state_all ~after obj
  method net_start =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.net_start ~after obj
  method net_stop =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.net_stop ~after obj
  method new_window ~callback: f =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.new_window ~after obj 
      ~callback: (fun chromes -> 
	let res = (f chromes : mozembed) in 
        (Obj.magic res#as_widget : GtkMozembed.mozembed Gtk.obj))
  method visibility =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.visibility ~after obj
  method destroy_browser =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.destroy_browser ~after obj
  method open_uri =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.open_uri ~after obj
  method size_to =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.size_to ~after obj
  method dom_key_down =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_key_down ~after obj
  method dom_key_press =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_key_press ~after obj
  method dom_key_up =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_key_up ~after obj
  method dom_mouse_down =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_mouse_down ~after obj
  method dom_mouse_up =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_mouse_up ~after obj
  method dom_mouse_click =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_mouse_click ~after obj
  method dom_mouse_dbl_click =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_mouse_dbl_click ~after obj
  method dom_mouse_over =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_mouse_over ~after obj
  method dom_mouse_out =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.dom_mouse_out ~after obj
(*
  method security_change =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.security_change ~after obj
  method status_change =
    GtkSignal.connect ~sgn:GtkMozembed.Signals.status_change ~after obj
*)

end 

and mozembed obj = object
  inherit mozembed_skel (obj : GtkMozembed.mozembed obj)
  method connect = new mozembed_signals obj
end

let mozembed ?packing ?show () =
  let w = create () in
  pack_return (new mozembed w) ~packing ~show
